<?php
if(!function_exists('sql_table'))	{
	function sql_table($name) {	return 'nucleus_'.$name;	}
}
class NP_CT extends NucleusPlugin {
	function getName() { return 'CT';	}
	function getAuthor() { return 'jun'; }
	function getURL() { return 'http://circle.club.or.jp/';	}
	function getVersion() { return '0.133';	}
	function getDescription() { return 'Comment and Trackback control.';	}
	function supportsFeature($what) {
		switch($what)	{
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	function install() {
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_ct').' (ctid int(11) not null auto_increment, ctbody text NOT NULL, ctuser varchar(40), ctmail varchar(100), ctmember int(11), ctitem int(11) NOT NULL, cttime datetime NOT NULL, cthost varchar(60), ctip varchar(15) NOT NULL, ctblog int(11) NOT NULL, ctmode char(1) not null, PRIMARY KEY (ctid))');
		$this -> createOption('del_uninstall', 'Delete tables on uninstall?', 'yesno', 'no');
		$this -> createOption('ctrl', '投稿されたコメントを保留しますか？', 'yesno', 'yes');
		$this -> createOption('quickmenu', 'quickmenu?', 'yesno', 'yes');
	}
	function unInstall() {
		if($this -> getOption('del_uninstall') == 'yes') {
			mysql_query ("DROP table ".sql_table('plugin_ct'));
		}
		$this -> deleteOption('del_uninstall');
		$this -> deleteOption('ctrl');
		$this -> deleteOption('quickmenu');
	}
	function getTableList() {
		return array(sql_table('plugin_ct'));
	}
	function getEventList() {
		return array('PreAddComment', 'QuickMenu');
	}
	function event_QuickMenu(&$data) {
		global $member;
		if($this->getOption('quickmenu') != 'yes') return;
		if($member->isLoggedIn()) {
			array_push(
				$data['options'],
				array(
					'title' => 'NP_CT',
					'url' => $this->getAdminURL(),
					'tooltip' => 'comment control'
				)
			);
		}
	}
	function hasAdminArea() {
		return 1;
	}
	function doAction($type) {
		if($type == 'delete')	{
			return $this -> delete();
			break;
		}
		exit;
	}
	function event_PreAddComment(&$data) {
		global $CONF, $member;
		if($this -> getOption('ctrl') != 'yes') {
			return;
		}else {
			if($member->isLoggedIn()) return;
		}
		$itemid = intval($data['comment']['itemid']);
		$comment = $data['comment'];
		$name = addslashes($comment['user']);
		$url = addslashes($comment['userid']);
		$body = addslashes($comment['body']);
		$host = addslashes($comment['host']);
		$ip = addslashes($comment['ip']);
		$memberid	= intval($comment['memberid']);
		$timestamp = date('Y-m-d H:i:s', $comment['timestamp']);
		$blogid = getBlogIDFromItemID($comment['itemid']);
		$result = mysql_query('SELECT cthost, ctip, ctmode FROM '.sql_table('plugin_ct'));
		while($row = mysql_fetch_assoc($result)) {
			if((preg_match("/".$row['cthost']."/", $host) || $row['ctip'] == $ip) && $row['ctmode'] == 1) {
				echo 'error';
				sql_query('INSERT INTO '.sql_table('plugin_ct')." (cthost, ctip, cttime, ctmode) VALUES ('$host', '$ip', '$timestamp' ,'2')");
				exit;
			}
		}
		mysql_free_result($result);
		sql_query('INSERT INTO '.sql_table('plugin_ct')." (ctbody, ctuser, ctmail, ctmember, ctitem, cttime, cthost, ctip, ctblog, ctmode) VALUES ('$body', '$name', '$url', '$memberid', '$itemid', '$timestamp', '$host', '$ip', '$blogid' ,'3')");
		echo '<html><head><meta http-equiv="Content-Type" content="text/html; charset=EUC-JP" /></head><body>コメントを受付けました。<br />ただし、現在、認証作業中なので、投稿されたコメントはすぐに反映されません。<p><a href="javascript:history.go(-1);">back</a></p><p><a href="'.$CONF['IndexURL'].'">Home</a></p></body></html>';
// send Mail
		@mb_language('Ja') ;
		@mb_internal_encoding('EUC-JP');
		$subject = 'コメント投稿 : '.$CONF['SiteName'];
		$message = "下記サイトへコメント投稿がありました。\n\n". $CONF['SiteName']."\n".$CONF['IndexURL']."\n\n";
		$message .= '名前 : '.$name."\n\n";
		$message .= 'コメント : '.$body."\n\n";
		$message .= 'ホスト : '.$host."\n\n";
		$message .= "コメントは保留されているので、\n下記ページにて認証作業を行なって下さい。\n";
		$message .= $CONF['AdminURL'].'plugins/ct/';
		$message .= getMailFooter();
		$mailfrom = 'From:'.$CONF['AdminEmail'];
		@mb_send_mail($CONF['AdminEmail'], $subject, $message, $mailfrom);
		exit();
	}
	function doSkinVar($skinType, $ctmode = '', $ctitem = '', $ctblog = '', $ctcat = '') {
		global $CONF, $manager, $blog, $blogid, $catid, $itemid, $member;
		$mode1 = substr($ctmode, 0, 1);
		$mode2 = substr($ctmode, 1, 1);
		$q0 = 'SELECT i.inumber, i.ititle, i.ibody, i.iblog, m.mname';
		$q1 = 'FROM '.sql_table('item').' as i, '.sql_table('blog').' as b, '.sql_table('category').' as c';
		$q2 = ' WHERE c.catid = i.icat and b.bnumber = c.cblog';
		if($mode1 != 't') {
			$q01 = ', co.cnumber, co.cbody, co.cuser, co.cmail, co.cmember, co.citem, co.ctime as mixtime, co.chost, co.cip, co.cblog ';
			$q11 = ', '.sql_table('comment').' as co left join '.sql_table('member').' as m on m.mnumber = co.cmember';
			$q21 = ' and co.citem = i.inumber';
			if($ctmode == 'c1') $q21 .= ' and co.citem = '.$itemid;
		}
		if($mode1 != 'c' && $manager -> pluginInstalled('NP_TrackBack')) {
			$q02 = ', tb.tb_id, tb.url, tb.title, tb.excerpt, tb.blog_name, tb.timestamp as mixtime ';
			$q12 = ', '.sql_table('plugin_tb').' as tb left join '.sql_table('member').' as m on i.iauthor = m.mnumber';
			$q22 = ' and tb.tb_id = i.inumber';
		}
		$query = $q0.$q01.$q02.$q1.$q11.$q12.$q2.$q21.$q22;
// category
		if($ctcat && $ctcat != 'b') {
			$ctcat = implode(', ', $ctcat);
			$query .= ' and i.icat in ('.$ctcat.')';
		}
// blog
		if($ctblog == 'all') {
			;
		}elseif($ctblog == '' || $ctblog == 0) {
			if($ctcat == 'b') {
				$query .= ' and i.iblog = '.$blogid;
			}else {
				$query .= (!$catid) ? ' and i.iblog = '.$blogid : ' and i.icat = '.$catid;
			}
		}else {
			$ctblog = str_replace('/', ', ', $ctblog);
			$query .= ' and i.iblog in ('.$ctblog.')';
		}
 		$ccount = mysql_num_rows(mysql_query($query));
// sort
		$query .= ' ORDER BY mixtime ';
		$query .= ($ctmode == 'c1') ? 'ASC' : 'DESC';
		$p0 = ($_GET['cpage']) ? $_GET['cpage'] : 1 ;
		$p01 = ($p0 - 1) * $ctitem;
		$query .= ' LIMIT '.$p01.','.$ctitem;
		$result = mysql_query($query);
// page switch
		if($p0 > 1) $p1 = $p0 - 1;
		$p2 = $p0 + 1;
		list($clink, $p3) = explode('cpage=', $_SERVER['REQUEST_URI'], 2);
		$p4 = ($p3 == '' && strpos($clink, '?')) ? '&amp;cpage=' : 'cpage=' ;
		if(!strpos($clink, '?')) $clink .= '?';
		$clink = str_replace('&&', '&', $clink);
		$last = ceil($ccount / $ctitem);
		$pswitch = '<p>';
		$pswitch .= ($p1) ? '<a href="'.$clink.$p4.'1" title="first page">&laquo;&laquo;</a> ' : '&laquo;&laquo; ';
		$pswitch .= ($p1) ? '<a href="'.$clink.$p4.$p1.'" title="prev page">&laquo;</a>' : '&laquo;';
		$pswitch .= ' [P.'.$p0.'/'.$last.'] ';
		$pswitch .= ($ccount > $p01 + $ctitem) ? '<a href="'.$clink.$p4.$p2.'" title="next page">&raquo;</a>' : '&raquo;';
		$pswitch .= ($ccount > $p01 + $ctitem) ? ' <a href="'.$clink.$p4.$last.'" title="last page">&raquo;&raquo;</a>' : ' &raquo;&raquo;';
		$pswitch .= '</p>';
//		if($mode2 == '2') echo $pswitch;
// print
		while($row = mysql_fetch_assoc($result)) {
			if($member -> isLoggedIn() && ( $member->isAdmin() || $member->isTeamMember($blogid))) {
				$del = ' <a href="'.$CONF['ActionURL'].'?action=plugin&amp;name=CT&amp;type=delete&amp;';
				$del .= ($mode1 == 'c') ? 'cid='.$row['cnumber'] : 'tid='.$row['tb_id'];
				$del .= '" title="Delete!!">del</a>';
				$ed = ' <a href="'.$CONF['AdminURL'].'index.php?action=commentedit&amp;commentid='.$row['cnumber'].'" title="Edit Comment" target="_blank">ed</a>';
			}
			if(!$row['cuser']) {
				$mem = $row['mname'];
				$murl = '<a href="'.$CONF['IndexURL'];
				$murl .= ($CONF['URLMode'] == 'pathinfo') ? 'member/' : 'index.php?memberid=' ;
				$murl .= $row['cmember'].'">'.$mem.'</a>';
			}else {
				$mem = $row['cuser'];
				if(preg_match("/@/i", $row['cmail'])) $cmail = 'mailto:';
				$cmail .= $row['cmail'];
				$murl = ($row['cmail']) ? '<a href="'.$cmail.'">'.$mem.'</a>' : $mem;
			}
			$ibody = shorten(strip_tags($row['ibody']), 70, '...');
			$cbody = strip_tags($row['cbody']);
			$cbodys = shorten($cbody, 70, '...');
			$excerpt = strip_tags($row['excerpt']);
			$excerpts = shorten($excerpt, 70, '...');
			$itemlink = createItemLink($row['inumber'], array('catid' => $row['icat']));
			$ititle = strip_tags($row['ititle']);
			$count = quickQuery('SELECT count(cnumber) as result FROM '.sql_table('comment').' WHERE citem = '.$row['inumber'].' and ctime <= "'.$row['mixtime'].'"');
			if($ctmode == 'c') {
//print comment short open
				$ec = 
'<a href="'.$itemlink.'#c'.$row['cnumber'].'" title="'.$cbodys.' ['.$row['mixtime'].']">
Re'.$count.':'.$ititle.'</a>('.$mem.')'.$ed.'<br />'
;
			}elseif($mode1 == 'c') {
//print comment full open
				$ec = 
'<form method="post" action="'.$itemlink.'#c'.$row['cnumber'].'">
<input name="iid" value="'.$row['inumber'].'" type="hidden" />
<input name="cid" value="'.$row['cnumber'].'" type="hidden" />
<input name="mem" value="'.$mem.'" type="hidden" />
<input name="cbody" value="'.$cbody.'" type="hidden" />

<div class="comment">
<a name="c'.$row['cnumber'].'">['.$row['cnumber'].']</a> 
<a href="'.$itemlink.'" title="'.$ibody.'">Re'.$count.':'.$ititle.'</a> 
<input value="返信" class="formbutton" type="submit" /> '.$del.'<br />
'.$murl.' <span class="iteminfo">'.$row['mixtime'].'</span>
</div>

<div class="commentbody">
'.$row['cbody'].'
</div>

</form>'
;
//print comment reply
				if(postVar('cid') == $row['cnumber']) {
					$ec .= 
'<form method="post" action="'.$CONF['ActionURL'].'">
<div class="commentform">
<input name="action" value="addcomment" type="hidden" />
<input name="url" value="'.$_SERVER['PHP_SELF'].'" type="hidden">
<input name="itemid" value="'.postVar('iid').'" type="hidden" />
<label for="nucleus_cf_body">['.$row['cnumber'].']への返信</label>:
<br />
<textarea name="body" class="formfield" cols="60" rows="10" id="nucleus_cf_body">>['.$row['cnumber']."]\n>".postVar('cbody').'</textarea><br />'
;
					if($member -> isLoggedIn()) {
						$memid = $member -> getID();
						$mem = quickQuery('SELECT mname as result FROM '.sql_table('member').' WHERE mnumber = '.$memid);
						$ec .= 
'ユーザー名: '.$mem.'<br />'
;
					}else {
						$ec .= 
'お名前: <input name="user" size="40" maxLength="40" /><br />
メールまたはWebサイト: <input name="userid" size="40" maxLength="60" /><br />
<input name="remember" value="1" type="checkbox" />情報を記憶しておく<br />'
;
					}
					$ec .= 
'<input value="コメントを追加" class="formbutton" type="submit" />
</div>
</form>
<hr /><br />'
;
				}
			}elseif($ctmode == 't') {
//print trackback short
				$ec = 
'<a href="'.$itemlink.'#t" title="'.$excerpt.' ['.$row['mixtime'].']">
'.$ititle.'</a>('.$row['title'].')'.$del.'<br />'
;
			}elseif($ctmode == 't2') {
//print trackback full
				$ec = 
'<div class="comment">
<a href="'.$itemlink.'" title="'.$ibody.'">Tb:'.$row['ititle'].'</a>'.$del.'<br />
<a href="'.$row['url'].'">'.$row['blog_name'].'</a> 
<span class="iteminfo">'.$row['mixtime'].'</span>
</div>
<div class="commentbody">'.$excerpt.'</div>
</form>'
;
			}
			print $ec;
		}
		if($mode2 == '2') echo $pswitch;
		if($member -> isLoggedIn()) {
			echo '<a href="'.$CONF['AdminURL'].'plugins/ct/" target="_blank">NP_CT admin</a>';
		}
	}
	function delete() {
		global $member, $manager, $HTTP_REFERER;
		if($member -> isLoggedIn() && ( $member->isAdmin() || $member->isTeamMember($blogid))) {
			$cid = intRequestVar('cid');
			if($cid) {
				$manager->notify('PreDeleteComment', array('commentid' => $commentid));
				mysql_query('DELETE FROM '.sql_table('comment').' WHERE cnumber = '.$cid);
				$manager->notify('PostDeleteComment', array('commentid' => $commentid));
			}
			$tid = intRequestVar('tid');
			if($tid) mysql_query('DELETE FROM '.sql_table('plugin_tb').' WHERE tb_id = '.$tid);
		}
		header('Location: ' . $HTTP_REFERER);
	}
}
?>